/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.game.logic;

import java.awt.Graphics2D;
import kinugasa.contents.resource.DynamicStorage;
import kinugasa.contents.resource.NameNotFoundException;
import kinugasa.game.GameLog;
import kinugasa.object.Drawable;

/**
 * 複数のゲームロジックを管理するためのクラスです.
 * <br>
 * <br>
 *
 * @version 1.0.0 - 2013/01/14_14:12:52<br>
 * @author Dra0211<br>
 */
public final class LogicManager extends DynamicStorage<GameLogic> implements Drawable {

	private GameLogic currentLogic = null;
	/**
	 * 唯一のインスタンスです.
	 */
	private static final LogicManager INSTANCE = new LogicManager();

	/**
	 * シングルトンクラスです. getInstanceを使用してください。<br>
	 */
	private LogicManager() {
	}

	/**
	 * インスタンスを取得します.
	 *
	 * @return LogicManagerのインスタンスを返します。<br>
	 */
	public static LogicManager getInstance() {
		return INSTANCE;
	}

	/**
	 * 稼働中のロジックを変更します. 次に実行されるロジックはnameという名前を持ちます。nameという名前のロジックが見つからない場合は例外を投げます。<br>
	 * このメソッドでは、現在稼働しているロジックの解放(freeのコール)と新しいロジックのロード(loadのコール)を行います。<br>
	 *
	 * @param name 次に実行するロジックの名前を指定します。<br>
	 *
	 * @throws NameNotFoundException 指定した名前のロジックが含まれていない場合に投げられます。<br>
	 */
	public void changeLogic(String name) throws NameNotFoundException {
		changeLogic(name, true, true);
	}

	/**
	 * 稼働中のロジックを変更します. 次に実行されるロジックはnameという名前を持ちます。nameという名前のロジックが見つからない場合は例外を投げます。<br>
	 * このメソッドでは、新しいロジックのロード(loadのコール)を行います。<br>
	 *
	 * @param name 次に実行するロジックの名前を指定します。<br>
	 * @param free trueを指定すると現在稼働中のロジックの解放(freeのコール)を行います。<br>
	 *
	 * @throws NameNotFoundException 指定した名前のロジックが含まれていない場合に投げられます。<br>
	 */
	public void changeLogic(String name, boolean free) throws NameNotFoundException {
		changeLogic(name, free, true);
	}

	/**
	 * 稼働中のロジックを変更します. 次に実行されるロジックはnameという名前を持ちます。nameという名前のロジックが見つからない場合は例外を投げます。<br>
	 *
	 * @param name 次に実行するロジックの名前を指定します。<br>
	 * @param free trueを指定すると現在稼働中のロジックの解放(freeのコール)を行います。<br>
	 * @param load trueを指定すると次に実行するロジックのロード(loadのコール)を行います。<br>
	 *
	 * @throws NameNotFoundException 指定した名前のロジックが含まれていない場合に投げられます。<br>
	 */
	public void changeLogic(String name, boolean free, boolean load) throws NameNotFoundException {
		if (!contains(name)) {
			throw new NameNotFoundException("logic not found : name=[" + name + "]");
		}
		if (free && currentLogic != null) {
			currentLogic.free();
		}
		//GameLog.printInfo("LogicManagerがロジックを変更します current=[" + currentLogic + "] next=[" + name + "]");
		currentLogic = get(name);
		if (load) {
			currentLogic.load();
		};
	}

	/**
	 * 現在使用しているロジックのupdateを呼び出します.
	 */
	public void update() {
		currentLogic.update();
	}

	/**
	 * 現在使用しているロジックのdrawを呼び出します.
	 *
	 * @param g 書き込むためのグラフィックスコンテキストを送信します。<br>
	 */
	@Override
	public void draw(Graphics2D g) {
		currentLogic.draw(g);
	}
}
